<?php
//////////////////////////////////////////////////////////////////////////////////
//    					 copyright (c) Arfooo Annuaire                          //
//   				 by Hocine Guillaume (c) 2007 - 2008                        //
//       					http://www.arfooo.com/                              //
//    Licence Creative Commons http://creativecommons.org/licenses/by/2.0/fr/   //
//////////////////////////////////////////////////////////////////////////////////

class AdModel extends Model
{   
    protected $primaryKey = "adId";
            
    function setAdOnPage($data)
    {
        $c = new Criteria();
        $c->add("page", $data['page']);
        $c->add("place", $data['place']);
        
        if($data['adCriterionId'] == 0 && $data['place'] != "general")
        {
            $this->ad->del($c);
        }
        else
        {
            $ad = $this->ad->find($c);
            
            if($ad)
            {
                $ad->adCriterionId = $data['adCriterionId'];
                $ad->save(); 
            }
            else
            {
                $ad = new AdRecord();
                $ad->fromArray($data);
                $ad->save();
            }
        }
    }
    
    function getAdsOnPage($page)
    {
        $c = new Criteria();
        $c->add("page", $page);
        $ads = array();
        
        foreach($this->findAll($c, "adCriterionId, place") as $ad)
        {            
            $ads[$ad['place']] = $ad['adCriterionId'];
        }
        
        if(substr_compare("site", $page, 0, 4) == 0 && !isset($ads['general']))
        {
            $siteId = substr($page, 4);
            
            $site = Model::factoryInstance("site")->findByPk($siteId, "categoryId");
            $ads['general'] = $this->isSiteAdsPredefinedInCategory($site->categoryId);
        }
        
        if(!isset($ads['general']))$ads['general'] = 0;
        if(!isset($ads['predefine']))$ads['predefine'] = 0;
        
        return $ads;
    }
    
    function getAllPredefinitions()
    {
        $c = new Criteria();
        $c->add("page", array("predefineCategory", "predefineSite", "predefineKeyword"), "IN");
        
        $predefinitions = array();
        
        foreach($this->findAll($c) as $ad)
        {
            $key = strtolower(substr($ad['page'], 9));
            $predefinitions[$key][$ad['place']] = $ad['adCriterionId']; 
        }
        
        return $predefinitions;
        
    }
    
    function isSiteAdsPredefinedInCategory($categoryId)
    {
        $c = new Criteria();
        $c->add("page", "category".$categoryId);
        $c->add("place", "predefine");
        
        return $this->getCount($c);
    }
}

class AdRecord extends ModelRecord
{
    
}

?>